using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace AxpDBNetCSSample.Samples
{
	/// <summary>
	/// Summary description for Calendar.
	/// </summary>
	public class Calendar : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList MonthSelect;
		protected System.Web.UI.WebControls.DropDownList YearSelect;
		protected System.Web.UI.WebControls.Calendar Cal;
		protected System.Web.UI.WebControls.Label lblDate;
		protected System.Web.UI.WebControls.Button OKButton;
		protected System.Web.UI.WebControls.Button CancelButton;
		protected System.Web.UI.HtmlControls.HtmlInputHidden datechosen;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!Page.IsPostBack)
			{
				string selected = Request.QueryString["selected"].ToString();
				string id = Request.QueryString["id"].ToString();
				string form = Request.QueryString["formname"].ToString();

				Cal.FirstDayOfWeek = FirstDayOfWeek.Default;

			// Select the Correct date for Calendar from query string
			// If fails, pick the current date on Calendar
				try
				{
					Cal.SelectedDate = Convert.ToDateTime(selected);
					Cal.VisibleDate = Convert.ToDateTime(selected);
				}
				catch
				{
					Cal.SelectedDate = DateTime.Today;
					Cal.VisibleDate = DateTime.Today;
				}

				// Fills in correct values for the dropdown menus
				FillCalendarChoices();
				SelectCorrectValues();

				// Add JScript to the OK button so that when the user clicks on it, the selected date
				// is passed back to the calling page.
				OKButton.Attributes.Add("onClick", "window.opener.SetDate('" + form + "','" + id + "', document.Calendar.datechosen.value);");
				CancelButton.Attributes.Add("onClick", "CloseWindow()");
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.MonthSelect.SelectedIndexChanged += new System.EventHandler(this.MonthSelect_SelectedIndexChanged);
			this.YearSelect.SelectedIndexChanged += new System.EventHandler(this.YearSelect_SelectedIndexChanged);
			this.Cal.SelectionChanged += new System.EventHandler(this.Cal_SelectionChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		//***************************************************************
		//
		// FillCalendarChoices method is used to fill dropdowns with month and year values 
		// 
		//***************************************************************

		private void FillCalendarChoices()
		{
			DateTime thisdate = new DateTime(DateTime.Today.Year, 1, 1);

			// Fills in month values
			for (int x = 0; x <= 11; x++)
			{
				// Loops through 12 months of the year and fills in each month value
				ListItem li = new ListItem(thisdate.ToString("MMMM"), thisdate.Month.ToString());
				MonthSelect.Items.Add(li);
				thisdate = thisdate.AddMonths(1);
			}

			// Fills in year values and change y value to other years if necessary
			
			for (int y = 1920 ; y<=thisdate.Year + 30; y++)
				YearSelect.Items.Add(y.ToString());
		}


		//***************************************************************************
		//
		// The SelectCorrectValues method is used to select the correct values in dropdowns 
		// according to the selected date on Calendar
		//
		//***************************************************************************

		private void SelectCorrectValues()
		{
			lblDate.Text = Cal.SelectedDate.ToShortDateString();
			datechosen.Value = lblDate.Text;
			MonthSelect.SelectedIndex = MonthSelect.Items.IndexOf(MonthSelect.Items.FindByValue(Cal.SelectedDate.Month.ToString()));
			YearSelect.SelectedIndex = YearSelect.Items.IndexOf(YearSelect.Items.FindByValue(Cal.SelectedDate.Year.ToString()));
		}

		private void Cal_SelectionChanged(object sender, System.EventArgs e)
		{
			Cal.VisibleDate = Cal.SelectedDate;
			SelectCorrectValues();	
		}

		private void MonthSelect_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Cal.VisibleDate = new DateTime(Convert.ToInt32(YearSelect.SelectedItem.Value), Convert.ToInt32(MonthSelect.SelectedItem.Value), 1);
			Cal.SelectedDate = Cal.VisibleDate;
			SelectCorrectValues();
		}

		private void YearSelect_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Cal.VisibleDate = new DateTime(Convert.ToInt32(YearSelect.SelectedItem.Value), Convert.ToInt32(MonthSelect.SelectedItem.Value), 1);
			Cal.SelectedDate = Cal.VisibleDate;
			SelectCorrectValues();		
		}
	}
}
