using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Configuration;

namespace AxpDBNetCSSample.Samples
{
	/// <summary>
	/// Summary description for Sample25.
	/// </summary>
	public class Sample25 : System.Web.UI.Page
	{
		protected Axezz.WebControls.AxpDataGrid AxpDataGrid1;

		
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.AxpDataGrid1.BeforeUpdateRecord += new Axezz.WebControls.AxpDataGrid.BeforeUpdateRecordEventHandler(this.AxpDataGrid1_BeforeUpdateRecord);
			this.AxpDataGrid1.BeforeInsertRecord += new Axezz.WebControls.AxpDataGrid.BeforeInsertRecordEventHandler(this.AxpDataGrid1_BeforeInsertRecord);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void Page_Load(object sender, System.EventArgs e)
		{
			AxpDataGrid1.ConnectionString = ConfigurationSettings.AppSettings["ConnectionString"];

			// Setting Productname to a required field since the grid is unable to detect it on some Access databases
			Axezz.WebControls.EditFieldItem efi = new Axezz.WebControls.EditFieldItem();
			efi.ColumnName = "ProductName";
			efi.Required = true;
			AxpDataGrid1.SetEditField(efi);

			// This sample might seem a bit meaningless but it does show how the various events and methods can be used.....

			// A read only drop down always defaulting to 1 in BeforeInsertRecord/BeforeUpdateRecord
			AxpDataGrid1.AddEditLookup("SupplierId", "Suppliers", "SupplierId", "CompanyName", "2", true);
			Axezz.WebControls.EditFieldItem efi2 = new Axezz.WebControls.EditFieldItem();
			efi2.ColumnName = "SupplierId";
			efi2.DefaultValue = 1;
			efi2.IsReadOnly = true;
			efi2.IsHardCoded = true;		 // needed when IsReadOnly = True and we want to alter/set the value in the BeforeInsertRecord/BeforeUpdateRecord
			AxpDataGrid1.SetEditField(efi2);

			// A hidden input field hard coded to 2 in BeforeInsertRecord/BeforeUpdateRecord
			Axezz.WebControls.EditFieldItem efi3 = new Axezz.WebControls.EditFieldItem();
			efi3.ColumnName = "CategoryId";
			efi3.Visible = false;
			AxpDataGrid1.SetEditField(efi3);
		}

		private void ValidateFields()
		{
			if (AxpDataGrid1.UpdateFields["QuantityPerUnit"] != null)
				if (AxpDataGrid1.UpdateFields["QuantityPerUnit"].ColumnValue.Trim().Length > 0)
				{
					int test=-1;
					try
					{
						test = int.Parse(AxpDataGrid1.UpdateFields["QuantityPerUnit"].ColumnValue);
					}
					catch
					{
						AxpDataGrid1.AbortCommandExecution();
						// Show error message below the input text field.
						Axezz.WebControls.EditFieldItem efi = new Axezz.WebControls.EditFieldItem();
						efi.ColumnName = "QuantityPerUnit";
						efi.HtmlAfter = "<font color='red'><strong>&nbsp;Must be a number</strong></font>";
						AxpDataGrid1.SetEditField(efi);
					}
					if (test < 0)
					{
						AxpDataGrid1.AbortCommandExecution();
						// Show error message below the input text field.
						Axezz.WebControls.EditFieldItem efi = new Axezz.WebControls.EditFieldItem();
						efi.ColumnName = "QuantityPerUnit";
						efi.HtmlAfter = "<font color='red'><strong>&nbsp;Must be a positive number</strong></font>";
						AxpDataGrid1.SetEditField(efi);
					}
				}
		}

		private void SetHardCodedValues()
		{
			// Note! All UpdateFields must be present in the Select query. E.g. The column "CategoryId"
			if (AxpDataGrid1.UpdateFields["SupplierId"] != null)
				AxpDataGrid1.UpdateFields["SupplierId"].ColumnValue = "1";
			if (AxpDataGrid1.UpdateFields["CategoryId"] != null)
				AxpDataGrid1.UpdateFields["CategoryId"].ColumnValue = "2";
		}

		private void AxpDataGrid1_BeforeInsertRecord(object sender, Axezz.WebControls.UpdateRecordEventArgs e)
		{
			ValidateFields();
			SetHardCodedValues();		
		}

		private void AxpDataGrid1_BeforeUpdateRecord(object sender, Axezz.WebControls.UpdateRecordEventArgs e)
		{		
			ValidateFields();
			SetHardCodedValues();
		}

	}
}
